#!/usr/bin/python2
#
# piClust
#
# Created by Inuk Jung on 2020-03-14.
# Copyright (c) 2020 Inuk Jung. All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

class ClusterTrack(object):
	def __init__(self, l):
		token=l.strip().split()
		self.chr=token[1].split(":")[0]
		self.spos=token[1].split(":")[1].split("-")[0]
		self.epos=token[1].split(":")[1].split("-")[1]
		self.clid="Cluster_"+token[3]+"_"+token[-1]
		self.score=0

		if "mixed" in token[-1] or "diverge" in token[-1]:
			self.strand="+"
		else:
			self.strand=token[-1]

	def __repr__(self):
		return "%s\t%s\t%s\t%s\t%d\t%s"%(self.chr,self.spos,self.epos,self.clid,self.score,self.strand)

class piRNATrack(object):
	def __init__(self, l):
		token=l.strip().split()
		self.chr=token[1]
		self.spos=token[4]
		self.epos=int(token[4])+int(token[5])
		if "gi" in token[2]:
			self.pid=token[2].split("|")[3]
		else:
			self.pid=token[2]
		self.score=0

		if "mixed" in token[-1]:
			self.strand=""
		else:
			self.strand=token[-1]

	def __repr__(self):
		return "%s\t%s\t%s\t%s\t%d\t%s"%(self.chr,self.spos,self.epos,self.pid,self.score,self.strand)

infile=open(sys.argv[1], 'r')

cluster_tracks=[]
pirna_tracks=[]
strand_dir=""
for line in infile.readlines():

	if line[0]=="@":
		if "mixed" not in line:
			strand_dir="single"
			cluster=ClusterTrack(line)
			cluster_tracks.append(cluster)
		else:
			strand_dir="mixed"
	else:
		if strand_dir != "mixed":
			pirna=piRNATrack(line)
			pirna_tracks.append(pirna)

# global setting header			
#global_setting="browser position chr1\n\
global_setting="browser hide all\n\
browser dense rmsk\n\
browser dense knownGene"
print global_setting

# cluster track header
track_name="piRNA cluster(s)"
track_db=sys.argv[2]
description="piRNA cluster(s)"
#visibility, squish|pack|full|dense|hide # default is hide (will also take numeric values 4|3|2|1|0)
visibility="full"
colorByStrand="255,0,0 0,0,255"
cluster_header="track name=\"%s\" db=\"%s\" description=\"%s\" visibility=%s colorByStrand=\"%s\""%(track_name,track_db,description,visibility,colorByStrand)
print cluster_header

for clust in cluster_tracks:
	print clust

# piRNA track header
track_name="piRNA transcripts"
description="piRNA transcripts"
visibility="pack"
colorByStrand="255,0,0 0,0,255"
pirna_header="track name=\"%s\" db=\"%s\" description=\"%s\" visibility=%s colorByStrand=\"%s\""%(track_name,track_db,description,visibility,colorByStrand)
print pirna_header
for pi in pirna_tracks:
	print pi

infile.close()
