#!/usr/bin/env Rscript

# plotting clusters
args <- commandArgs(TRUE)
png_file <- paste(args[2], ".png", sep="")

png(png_file)
data <-read.table(args[1], header=F)
max_x <- max(data$V1)
min_x<-min(data$V1)
plot(data, type="h", xlim=c(min_x, max_x), yaxt="n", xlab="Position of piRNAs in genome", ylab="Strand direction", ylim=c(-1.2,1.2), bty="n", main=args[3])

axis(2, at=-1:1, labels=c("minus"," ","plus"), tck=0)
axis(1)

abline(h=0, col="black")
graphics.off()
