#!/usr/bin/env python

import sys
import os
import subprocess
import operator

infile = open(sys.argv[1], 'r')
outdir = os.path.dirname(os.path.realpath(sys.argv[1])) + "/plots"
rscript = sys.argv[2]

chr=""
clid=""
init=True
cluster=[]
per_chr={}


line=infile.readline()
while True:

	if(not line or line[0]=="@"):
		token = line.strip().split()
		if(init==True):
			init=False
			if "gi|" in token[1]:
				chrid=token[1].split(":")[0].split("|")[3]
			else: chrid=token[1].split(":")[0]
			#chrid=token[1].strip()
			clid="%s_Cluster%s"%(chrid,token[3])
			strand_str = token[13]
		else:
			# write transcript strand information to temporary file (data.plot)
			tmpfile = outdir+"/data.plot"
			outfile=open(tmpfile, 'w')

			for i in range(len(cluster)):
				outfile.write(cluster[i]+"\n")
			outfile.close()
			
			if strand_str == '+':
				strand_dir = "plus"
			elif strand_str == '-':
				strand_dir = "minus"
			else: strand_dir = strand_str

			# run r_script to generate png image files
			r_file = outdir + '/' +  clid + '_' + strand_dir
			comm = [rscript,tmpfile,r_file,clid+" (strand:"+strand_str+")"]
			cmd = subprocess.Popen(comm, shell=False)
			cmd.communicate()

			# only handle directional clusters
			if strand_str!="mixed":
				# catalogue image files per chromosome
				# only collect clusters with strand bias
				if chrid not in per_chr:
					per_chr[chrid]=[]
				if chrid.isdigit():
					per_chr[chrid].append([int(chrid), r_file+".png"])
				else:
					per_chr[chrid].append([chrid, r_file+".png"])

			# break if EOF
			if not line:
				break

			# start next cluster
			cluster=[]
			if "gi|" in token[1]:
				chrid=token[1].split(":")[0].split("|")[3]
			else: chrid=token[1].split(":")[0]
			clid="%s_Cluster%s"%(chrid,token[3])
			#chrid=token[1].strip()
			strand_str = token[13]


	else:
		token = line.strip().split()
		# collect transcripts
		pos=token[4]
		if(token[7]=="+"): 
			strand=1
		elif(token[7]=="-"):
			strand=-1
		cluster.append("%s\t%s"%(pos,strand))


	line=infile.readline()

infile.close()
if len(cluster):
	comm = "rm "+tmpfile
	cmd = subprocess.Popen(comm, shell=True)
	cmd.communicate()

# output list of clusters per chromosome
# outfile=open(outdir+"/pnglist.txt", 'w')
# chr_clusters=sorted(per_chr.items(), key=lambda x:x[1][0])
# for chr in chr_clusters:
# 	outfile.write(chr[0]+" "),	
# 	for clust in chr[1]:
# 		outfile.write(clust[1]+" "),
# 	outfile.write("\n")
# outfile.close()


